//---------------------------------------------------------------------------
#include <vcl\vcl.h>
#pragma hdrstop

#include "Unit1.h"
//---------------------------------------------------------------------------
#pragma link "comthread"
#pragma resource "*.dfm"
TForm1 *Form1;
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
	: TForm(Owner)
{
}
//---------------------------------------------------------------------------
void __fastcall TForm1::FormCreate(TObject *Sender)
{
	CBBaud->ItemIndex = 5;
	CBPort->ItemIndex = 1;
	CBData->ItemIndex = 3;
	CBStop->ItemIndex = 0;
	CBParity->ItemIndex = 2;

	ComThread1->ComInit();
		if( !ComThread1->ok)
			Memo1->Lines->Add( ComThread1->errMsg);
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Memo1KeyPress(TObject *Sender, char &Key)
{
	ComThread1->Write( Key);
	if( !ComThread1->ok)
		Memo1->Lines->Add( ComThread1->errMsg);
	Key=0;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::CBPortChange(TObject *Sender)
{
	const unsigned int p = CBPort->Items->Strings[ CBPort->ItemIndex].ToInt();
  if( ComThread1->Port == p) return;

	ComThread1->ComClose();
	ComThread1->Port = p;
	ComThread1->ComInit();
	if( !ComThread1->ok)
		Memo1->Lines->Add( ComThread1->errMsg);
	else
		Memo1->Lines->Add( "New port selected.");
}
//---------------------------------------------------------------------------
void __fastcall TForm1::CBBaudChange(TObject *Sender)
{
	const unsigned int b = CBBaud->Items->Strings[ CBBaud->ItemIndex].ToInt();
  if( ComThread1->Baud == b) return;

	ComThread1->ComClose();
	ComThread1->Baud = b;
	ComThread1->ComInit();
	if( !ComThread1->ok)
  	Memo1->Lines->Add( ComThread1->errMsg);
	else
  	Memo1->Lines->Add( "New Baudrate selected.");
}
//---------------------------------------------------------------------------
void __fastcall TForm1::CBDataChange(TObject *Sender)
{
	const unsigned int d = CBData->Items->Strings[ CBData->ItemIndex].ToInt();
  if( ComThread1->DataBits == d) return;

	ComThread1->ComClose();
	ComThread1->DataBits = d;
	ComThread1->ComInit();
	if( !ComThread1->ok)
  	Memo1->Lines->Add( ComThread1->errMsg);
	else
		Memo1->Lines->Add( "New DataBits selected.");
}
//---------------------------------------------------------------------------
void __fastcall TForm1::CBStopChange(TObject *Sender)
{
	const TComThread::TStopBits sb[3] = {TComThread::s1, TComThread::s1_5, TComThread::s2};
  const int s = CBStop->ItemIndex;
  if( ComThread1->StopBits == sb[s]) return;

	ComThread1->ComClose();
	ComThread1->StopBits = sb[s];
	ComThread1->ComInit();
	if( !ComThread1->ok)
  	Memo1->Lines->Add( ComThread1->errMsg);
	else
		Memo1->Lines->Add( "New StopBits selected.");
}
//---------------------------------------------------------------------------
void __fastcall TForm1::CBParityChange(TObject *Sender)
{
	const TComThread::TParity pr[5] = {TComThread::even, TComThread::mark, TComThread::none, TComThread::odd, TComThread::space};
  const int p = CBParity->ItemIndex;
  if( ComThread1->Parity == pr[p]) return;

	ComThread1->ComClose();
  ComThread1->Parity = pr[p];
	ComThread1->ComInit();
	if( !ComThread1->ok)
		Memo1->Lines->Add( ComThread1->errMsg);
	else
		Memo1->Lines->Add( "New Parity selected.");
}
//---------------------------------------------------------------------------
// NOTE : PacketReceived() is called using 'Synchronize()' from the comthread
// 				treat this function as if it were an ISR...
//---------------------------------------------------------------------------
void __fastcall TForm1::ComThread1PacketReceived(TObject *Sender,
	AnsiString &buffer)
{
#define BUF_SIZE 2000

String stub = "binary:";
bool bin=false;
for( int i=1; i<=buffer.Length(); i++){
	if( buffer[i]<9) {
		buffer[i] = ('0' + ((char)buffer[i]));
		bin=true;
	}
	if( buffer[i] == 13)
		buffer = buffer.SubString(1, i) + "\n" + buffer.SubString( i+1, buffer.Length()-1);

}
if( bin)
buffer = stub + buffer + "\r\n";

  Memo1->Lines->BeginUpdate();
	long n = Memo1->Text.Length() + buffer.Length();
  while( n > BUF_SIZE){
  	Memo1->Lines->Delete(0);
    n = Memo1->Text.Length() + buffer.Length();
  }

  Memo1->SelStart = Memo1->Text.Length();
  Memo1->SelLength = 0;
  Memo1->Lines->EndUpdate();

	Memo1->SelText = buffer;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::BinaryClick(TObject *Sender)
{
	char buf[10] = { 0, 1, 0, 1, 0, 1, 0, 1, 0, 1};
	ComThread1->Write( buf, 10);
}
//---------------------------------------------------------------------------
